--doomsday plugin by CrazySpence 0.1

local TCP = dofile("tcpsock.lua")

local doomsday = nil
local doomsday_nick = nil

local function dday_login(_,args)
   if not args then
      print("Missing login parameters: /ddaylogin Someguy Somepassword")
   else
      if doomsday then
         doomsday:Send("DATA " .. args[1] .. " LOGIN " .. args[2])
         doomsday_nick = args[1]
      end
   end
end

local function dday_cmd(_,args)
   if not args then
      print("No command given")
   else
      if doomsday then
         if doomsday_nick  then
            doomsday:Send("DATA " .. doomsday_nick .. " " .. table.concat(args," ")) 
         end
      end
   end
end

local function Connected(conn,success)
   if conn then
      print("Connected to Doomsday game server")
   else
      print(success)
      doomsday = nil
   end
end

local function Disconnected()
   print("Connection to Doomsday interrupted")
   if doomsday then
      doomsday = nil
   end
end

local function Incoming(conn,line)
   if line == "PING" then
      doomsday:Send("PONG")
   else 
      print(line)
   end
end

local function game_init()
   if not doomsday then
      doomsday = TCP.make_client("doomsday.philtopia.com", "10001", Connected, Incoming, Disconnected)
   else
      print("Doomsday is already connected")
   end
end

local function game_end()
   if doomsday then
      doomsday.tcp:Disconnect()
      doomsday = nil
      if doomsday_nick then
         doomsday_nick = nil
      end
   end
end

RegisterUserCommand("ddaylogin", dday_login)
RegisterUserCommand("ddaynewplayer",dday_newplayer)
RegisterUserCommand("dday",dday_cmd)
RegisterUserCommand("ddaystart",game_init)
RegisterUserCommand("ddaystop",game_end)